package org.keeper.iot.wsn.plc.messages.appgenerics;

import static com.esotericsoftware.minlog.Log.LEVEL_TRACE;
import static com.esotericsoftware.minlog.Log.trace;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.BeforeClass;
import org.junit.Test;
import org.keeper.iot.wsn.plc.messages.Message;
import org.keeper.iot.wsn.plc.messages.MessageFields;
import org.keeper.utils.Helpers;

import com.esotericsoftware.minlog.Log;

import java.net.InetAddress;
import java.net.UnknownHostException;

public class AppGenericsGetCapabilitiesResponseTest {
  public static final String TAG = "Test";

  /**
   * @throws java.lang.Exception
   */
  @BeforeClass
  public static void setUpBeforeClass() throws Exception {
    Log.set(LEVEL_TRACE);
  }

  @Test
  public void test() {
    byte[] data =
        {0x6b, 0x00, (byte) 0xfe, 0x65, 0x00, 0x07, 0x01, 0x00, 0x00, 0x00, 0x02, 0x03, 0x01, 0x02,
            0x05, 0x07, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x04, 0x00, 0x01, 0x04, 0x05,
            0x00, 0x01, 0x00, 0x02, 0x00, 0x01, 0x03, 0x00, 0x01, 0x02, 0x02, 0x00, 0x03, 0x00,
            0x0e, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x67, 0x68,
            0x6d, 0x02, 0x00, 0x03, 0x00, 0x07, 0x06, 0x09, 0x56, 0x57, 0x61, 0x62, 0x6a, 0x02,
            0x00, 0x03, 0x00, 0x07, 0x07, 0x0a, 0x58, 0x59, 0x63, 0x64, 0x6b, 0x02, 0x00, 0x03,
            0x00, 0x07, 0x08, 0x0b, 0x5a, 0x5b, 0x65, 0x66, 0x6c, 0x02, 0x00, 0x02, 0x00, 0x02,
            0x00, 0x01, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, (byte) 0xfc};

    InetAddress address = null;
    try {
      address = InetAddress.getByName("192.168.100.1");
    } catch (UnknownHostException e) {
      e.printStackTrace();
      fail("Should not happen");
    }

    Message msg = new AppGenericsGetCapabilitiesResponse(address, data);

    assertTrue(Helpers.compareArrays(data, msg.getRaw()));

    trace(TAG, "Message .toString:" + msg);
  }


  /**
   * In this case the message has 3 subsystems but we say it has 4 and the following byte says
   * (incorrectly) there are 0 endpoints so we fall short of parsing the entire message content
   * and therefore the constructor should fail.
   */
  @Test(expected = IllegalArgumentException.class)
  public void badMessageTest() {
    InetAddress address = null;
    try {
      address = InetAddress.getByName("192.168.100.1");
    } catch (UnknownHostException e) {
      e.printStackTrace();
      fail("Should not happen");
    }

    byte[] data =
        {0x6b, 0x00, (byte) 0xfe, 0x65, 0x00, 0x07, 0x01, 0x00, 0x00, 0x00, 0x02, 0x04, 0x01, 0x02,
            0x05, 0x07, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x04, 0x00, 0x01, 0x04, 0x05,
            0x00, 0x01, 0x00, 0x02, 0x00, 0x01, 0x03, 0x00, 0x01, 0x02, 0x02, 0x00, 0x03, 0x00,
            0x0e, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x67, 0x68,
            0x6d, 0x02, 0x00, 0x03, 0x00, 0x07, 0x06, 0x09, 0x56, 0x57, 0x61, 0x62, 0x6a, 0x02,
            0x00, 0x03, 0x00, 0x07, 0x07, 0x0a, 0x58, 0x59, 0x63, 0x64, 0x6b, 0x02, 0x00, 0x03,
            0x00, 0x07, 0x08, 0x0b, 0x5a, 0x5b, 0x65, 0x66, 0x6c, 0x02, 0x00, 0x02, 0x00, 0x02,
            0x00, 0x01, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00};

    MessageFields.setChecksumAuto(data);

    @SuppressWarnings("unused")
    Message badMessage0 = new AppGenericsGetCapabilitiesResponse(address, data);
  }

  /**
   * In this case the last endpoint/cluster has a +1 number of attributes, so the message length
   * should fall short.
   */
  @Test(expected = IllegalArgumentException.class)
  public void badMessage2Test() {
    InetAddress address = null;
    try {
      address = InetAddress.getByName("192.168.100.1");
    } catch (UnknownHostException e) {
      e.printStackTrace();
      fail("Should not happen");
    }

    byte[] data =
        {0x6b, 0x00, (byte) 0xfe, 0x65, 0x00, 0x07, 0x01, 0x00, 0x00, 0x00, 0x02, 0x03, 0x01, 0x02,
            0x05, 0x07, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x04, 0x00, 0x01, 0x04, 0x05,
            0x00, 0x01, 0x00, 0x02, 0x00, 0x01, 0x03, 0x00, 0x01, 0x02, 0x02, 0x00, 0x03, 0x00,
            0x0e, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x5c, 0x5d, 0x5e, 0x5f, 0x60, 0x67, 0x68,
            0x6d, 0x02, 0x00, 0x03, 0x00, 0x07, 0x06, 0x09, 0x56, 0x57, 0x61, 0x62, 0x6a, 0x02,
            0x00, 0x03, 0x00, 0x07, 0x07, 0x0a, 0x58, 0x59, 0x63, 0x64, 0x6b, 0x02, 0x00, 0x03,
            0x00, 0x07, 0x08, 0x0b, 0x5a, 0x5b, 0x65, 0x66, 0x6c, 0x02, 0x00, 0x02, 0x00, 0x02,
            0x00, 0x01, 0x02, 0x00, 0x02, 0x00, 0x03, 0x00, 0x01, 0x00, 0x00};

    MessageFields.setChecksumAuto(data);

    @SuppressWarnings("unused")
    Message badMessage0 = new AppGenericsGetCapabilitiesResponse(address, data);
  }

}
